'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var module$1 = require('module');
var sewingKit = require('@quilted/sewing-kit');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

const require$1 = module$1.createRequire((typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('index.cjs', document.baseURI).href)));
/**
 * Adds basic Babel hooks that other plugins can attach configuration to.
 */


function babelHooks() {
  return sewingKit.createProjectPlugin({
    name: 'SewingKit.Babel',

    build({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    },

    develop({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    },

    test({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    }

  });
}
/**
 * Adds basic Babel hooks that other plugins can attach configuration to
 * for configuring Babel at the workspace level.
 */

function babelWorkspaceHooks() {
  return sewingKit.createWorkspacePlugin({
    name: 'SewingKit.Babel.Workspace',

    build({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    },

    develop({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    },

    test({
      hooks
    }) {
      hooks(({
        waterfall
      }) => ({
        babelPlugins: waterfall(),
        babelPresets: waterfall(),
        babelExtensions: waterfall(),
        babelTargets: waterfall()
      }));
    }

  });
}
function babelRollup() {
  return sewingKit.createProjectPlugin({
    name: 'SewingKit.Babel.Rollup',

    build({
      project,
      configure
    }) {
      configure(({
        extensions,
        babelPresets,
        babelPlugins,
        babelTargets,
        babelExtensions,
        rollupPlugins
      }) => {
        rollupPlugins?.(async plugins => {
          const helpers = project.kind === sewingKit.ProjectKind.Package ? 'runtime' : 'bundled';
          const [{
            babel
          }, targets, baseExtensions, babelPresetsOption, babelPluginsOption] = await Promise.all([Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('@rollup/plugin-babel')); }), babelTargets.run([]), extensions.run(['.mjs', '.cjs', '.js']), babelPresets.run([]), babelPlugins.run(helpers === 'runtime' ? [require$1.resolve('@babel/plugin-transform-runtime')] : [])]);
          const finalExtensions = await babelExtensions.run(baseExtensions);
          return [...plugins, babel({
            envName: 'production',
            extensions: finalExtensions,
            exclude: 'node_modules/**',
            babelHelpers: helpers,
            configFile: false,
            babelrc: false,
            skipPreflightCheck: true,
            // @ts-expect-error Babel types have not been updated yet
            targets,
            presets: babelPresetsOption,
            plugins: babelPluginsOption
          })];
        });
      });
    },

    develop({
      project,
      configure
    }) {
      configure(({
        extensions,
        babelPresets,
        babelPlugins,
        babelTargets,
        babelExtensions,
        rollupPlugins
      }) => {
        rollupPlugins?.(async plugins => {
          const helpers = project.kind === sewingKit.ProjectKind.Package ? 'runtime' : 'bundled';
          const [{
            babel
          }, targets, baseExtensions, babelPresetsOption, babelPluginsOption] = await Promise.all([Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('@rollup/plugin-babel')); }), babelTargets.run([]), extensions.run(['.mjs', '.cjs', '.js']), babelPresets.run([]), babelPlugins.run(helpers === 'runtime' ? [require$1.resolve('@babel/plugin-transform-runtime')] : [])]);
          const finalExtensions = await babelExtensions.run(baseExtensions);
          return [...plugins, babel({
            envName: 'production',
            extensions: finalExtensions,
            exclude: 'node_modules/**',
            babelHelpers: helpers,
            configFile: false,
            babelrc: false,
            skipPreflightCheck: true,
            // @ts-expect-error Babel types have not been updated yet
            targets,
            presets: babelPresetsOption,
            plugins: babelPluginsOption
          })];
        });
      });
    }

  });
}

exports.babelHooks = babelHooks;
exports.babelRollup = babelRollup;
exports.babelWorkspaceHooks = babelWorkspaceHooks;
